# coding: utf-8

"""
    PeerTube

    # Introduction  The PeerTube API is built on HTTP(S) and is RESTful. You can use your favorite HTTP/REST library for your programming language to use PeerTube. The spec API is fully compatible with [openapi-generator](https://github.com/OpenAPITools/openapi-generator/wiki/API-client-generator-HOWTO) which generates a client SDK in the language of your choice - we generate some client SDKs automatically:  - [Python](https://framagit.org/framasoft/peertube/clients/python) - [Go](https://framagit.org/framasoft/peertube/clients/go) - [Kotlin](https://framagit.org/framasoft/peertube/clients/kotlin)  See the [Quick Start guide](https://docs.joinpeertube.org/#/api-rest-getting-started) so you can play with the PeerTube API.  # Authentication  When you sign up for an account, you are given the possibility to generate sessions, and authenticate using this session token. One session token can currently be used at a time.  ## Roles  Accounts are given permissions based on their role. There are three roles on PeerTube: Administrator, Moderator, and User. See the [roles guide](https://docs.joinpeertube.org/#/admin-managing-users?id=roles) for a detail of their permissions.  # Errors  The API uses standard HTTP status codes to indicate the success or failure of the API call. The body of the response will be JSON in the following format.  ``` {   \"code\": \"unauthorized_request\", // example inner error code   \"error\": \"Token is invalid.\" // example exposed error message } ```   # noqa: E501

    The version of the OpenAPI document: 2.4.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from peertube.configuration import Configuration


class InlineObject3(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'new_video_from_subscription': 'NotificationSettingValue',
        'new_comment_on_my_video': 'NotificationSettingValue',
        'abuse_as_moderator': 'NotificationSettingValue',
        'video_auto_blacklist_as_moderator': 'NotificationSettingValue',
        'blacklist_on_my_video': 'NotificationSettingValue',
        'my_video_published': 'NotificationSettingValue',
        'my_video_import_finished': 'NotificationSettingValue',
        'new_follow': 'NotificationSettingValue',
        'new_user_registration': 'NotificationSettingValue',
        'comment_mention': 'NotificationSettingValue',
        'new_instance_follower': 'NotificationSettingValue',
        'auto_instance_following': 'NotificationSettingValue'
    }

    attribute_map = {
        'new_video_from_subscription': 'newVideoFromSubscription',
        'new_comment_on_my_video': 'newCommentOnMyVideo',
        'abuse_as_moderator': 'abuseAsModerator',
        'video_auto_blacklist_as_moderator': 'videoAutoBlacklistAsModerator',
        'blacklist_on_my_video': 'blacklistOnMyVideo',
        'my_video_published': 'myVideoPublished',
        'my_video_import_finished': 'myVideoImportFinished',
        'new_follow': 'newFollow',
        'new_user_registration': 'newUserRegistration',
        'comment_mention': 'commentMention',
        'new_instance_follower': 'newInstanceFollower',
        'auto_instance_following': 'autoInstanceFollowing'
    }

    def __init__(self, new_video_from_subscription=None, new_comment_on_my_video=None, abuse_as_moderator=None, video_auto_blacklist_as_moderator=None, blacklist_on_my_video=None, my_video_published=None, my_video_import_finished=None, new_follow=None, new_user_registration=None, comment_mention=None, new_instance_follower=None, auto_instance_following=None, local_vars_configuration=None):  # noqa: E501
        """InlineObject3 - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._new_video_from_subscription = None
        self._new_comment_on_my_video = None
        self._abuse_as_moderator = None
        self._video_auto_blacklist_as_moderator = None
        self._blacklist_on_my_video = None
        self._my_video_published = None
        self._my_video_import_finished = None
        self._new_follow = None
        self._new_user_registration = None
        self._comment_mention = None
        self._new_instance_follower = None
        self._auto_instance_following = None
        self.discriminator = None

        if new_video_from_subscription is not None:
            self.new_video_from_subscription = new_video_from_subscription
        if new_comment_on_my_video is not None:
            self.new_comment_on_my_video = new_comment_on_my_video
        if abuse_as_moderator is not None:
            self.abuse_as_moderator = abuse_as_moderator
        if video_auto_blacklist_as_moderator is not None:
            self.video_auto_blacklist_as_moderator = video_auto_blacklist_as_moderator
        if blacklist_on_my_video is not None:
            self.blacklist_on_my_video = blacklist_on_my_video
        if my_video_published is not None:
            self.my_video_published = my_video_published
        if my_video_import_finished is not None:
            self.my_video_import_finished = my_video_import_finished
        if new_follow is not None:
            self.new_follow = new_follow
        if new_user_registration is not None:
            self.new_user_registration = new_user_registration
        if comment_mention is not None:
            self.comment_mention = comment_mention
        if new_instance_follower is not None:
            self.new_instance_follower = new_instance_follower
        if auto_instance_following is not None:
            self.auto_instance_following = auto_instance_following

    @property
    def new_video_from_subscription(self):
        """Gets the new_video_from_subscription of this InlineObject3.  # noqa: E501


        :return: The new_video_from_subscription of this InlineObject3.  # noqa: E501
        :rtype: NotificationSettingValue
        """
        return self._new_video_from_subscription

    @new_video_from_subscription.setter
    def new_video_from_subscription(self, new_video_from_subscription):
        """Sets the new_video_from_subscription of this InlineObject3.


        :param new_video_from_subscription: The new_video_from_subscription of this InlineObject3.  # noqa: E501
        :type new_video_from_subscription: NotificationSettingValue
        """

        self._new_video_from_subscription = new_video_from_subscription

    @property
    def new_comment_on_my_video(self):
        """Gets the new_comment_on_my_video of this InlineObject3.  # noqa: E501


        :return: The new_comment_on_my_video of this InlineObject3.  # noqa: E501
        :rtype: NotificationSettingValue
        """
        return self._new_comment_on_my_video

    @new_comment_on_my_video.setter
    def new_comment_on_my_video(self, new_comment_on_my_video):
        """Sets the new_comment_on_my_video of this InlineObject3.


        :param new_comment_on_my_video: The new_comment_on_my_video of this InlineObject3.  # noqa: E501
        :type new_comment_on_my_video: NotificationSettingValue
        """

        self._new_comment_on_my_video = new_comment_on_my_video

    @property
    def abuse_as_moderator(self):
        """Gets the abuse_as_moderator of this InlineObject3.  # noqa: E501


        :return: The abuse_as_moderator of this InlineObject3.  # noqa: E501
        :rtype: NotificationSettingValue
        """
        return self._abuse_as_moderator

    @abuse_as_moderator.setter
    def abuse_as_moderator(self, abuse_as_moderator):
        """Sets the abuse_as_moderator of this InlineObject3.


        :param abuse_as_moderator: The abuse_as_moderator of this InlineObject3.  # noqa: E501
        :type abuse_as_moderator: NotificationSettingValue
        """

        self._abuse_as_moderator = abuse_as_moderator

    @property
    def video_auto_blacklist_as_moderator(self):
        """Gets the video_auto_blacklist_as_moderator of this InlineObject3.  # noqa: E501


        :return: The video_auto_blacklist_as_moderator of this InlineObject3.  # noqa: E501
        :rtype: NotificationSettingValue
        """
        return self._video_auto_blacklist_as_moderator

    @video_auto_blacklist_as_moderator.setter
    def video_auto_blacklist_as_moderator(self, video_auto_blacklist_as_moderator):
        """Sets the video_auto_blacklist_as_moderator of this InlineObject3.


        :param video_auto_blacklist_as_moderator: The video_auto_blacklist_as_moderator of this InlineObject3.  # noqa: E501
        :type video_auto_blacklist_as_moderator: NotificationSettingValue
        """

        self._video_auto_blacklist_as_moderator = video_auto_blacklist_as_moderator

    @property
    def blacklist_on_my_video(self):
        """Gets the blacklist_on_my_video of this InlineObject3.  # noqa: E501


        :return: The blacklist_on_my_video of this InlineObject3.  # noqa: E501
        :rtype: NotificationSettingValue
        """
        return self._blacklist_on_my_video

    @blacklist_on_my_video.setter
    def blacklist_on_my_video(self, blacklist_on_my_video):
        """Sets the blacklist_on_my_video of this InlineObject3.


        :param blacklist_on_my_video: The blacklist_on_my_video of this InlineObject3.  # noqa: E501
        :type blacklist_on_my_video: NotificationSettingValue
        """

        self._blacklist_on_my_video = blacklist_on_my_video

    @property
    def my_video_published(self):
        """Gets the my_video_published of this InlineObject3.  # noqa: E501


        :return: The my_video_published of this InlineObject3.  # noqa: E501
        :rtype: NotificationSettingValue
        """
        return self._my_video_published

    @my_video_published.setter
    def my_video_published(self, my_video_published):
        """Sets the my_video_published of this InlineObject3.


        :param my_video_published: The my_video_published of this InlineObject3.  # noqa: E501
        :type my_video_published: NotificationSettingValue
        """

        self._my_video_published = my_video_published

    @property
    def my_video_import_finished(self):
        """Gets the my_video_import_finished of this InlineObject3.  # noqa: E501


        :return: The my_video_import_finished of this InlineObject3.  # noqa: E501
        :rtype: NotificationSettingValue
        """
        return self._my_video_import_finished

    @my_video_import_finished.setter
    def my_video_import_finished(self, my_video_import_finished):
        """Sets the my_video_import_finished of this InlineObject3.


        :param my_video_import_finished: The my_video_import_finished of this InlineObject3.  # noqa: E501
        :type my_video_import_finished: NotificationSettingValue
        """

        self._my_video_import_finished = my_video_import_finished

    @property
    def new_follow(self):
        """Gets the new_follow of this InlineObject3.  # noqa: E501


        :return: The new_follow of this InlineObject3.  # noqa: E501
        :rtype: NotificationSettingValue
        """
        return self._new_follow

    @new_follow.setter
    def new_follow(self, new_follow):
        """Sets the new_follow of this InlineObject3.


        :param new_follow: The new_follow of this InlineObject3.  # noqa: E501
        :type new_follow: NotificationSettingValue
        """

        self._new_follow = new_follow

    @property
    def new_user_registration(self):
        """Gets the new_user_registration of this InlineObject3.  # noqa: E501


        :return: The new_user_registration of this InlineObject3.  # noqa: E501
        :rtype: NotificationSettingValue
        """
        return self._new_user_registration

    @new_user_registration.setter
    def new_user_registration(self, new_user_registration):
        """Sets the new_user_registration of this InlineObject3.


        :param new_user_registration: The new_user_registration of this InlineObject3.  # noqa: E501
        :type new_user_registration: NotificationSettingValue
        """

        self._new_user_registration = new_user_registration

    @property
    def comment_mention(self):
        """Gets the comment_mention of this InlineObject3.  # noqa: E501


        :return: The comment_mention of this InlineObject3.  # noqa: E501
        :rtype: NotificationSettingValue
        """
        return self._comment_mention

    @comment_mention.setter
    def comment_mention(self, comment_mention):
        """Sets the comment_mention of this InlineObject3.


        :param comment_mention: The comment_mention of this InlineObject3.  # noqa: E501
        :type comment_mention: NotificationSettingValue
        """

        self._comment_mention = comment_mention

    @property
    def new_instance_follower(self):
        """Gets the new_instance_follower of this InlineObject3.  # noqa: E501


        :return: The new_instance_follower of this InlineObject3.  # noqa: E501
        :rtype: NotificationSettingValue
        """
        return self._new_instance_follower

    @new_instance_follower.setter
    def new_instance_follower(self, new_instance_follower):
        """Sets the new_instance_follower of this InlineObject3.


        :param new_instance_follower: The new_instance_follower of this InlineObject3.  # noqa: E501
        :type new_instance_follower: NotificationSettingValue
        """

        self._new_instance_follower = new_instance_follower

    @property
    def auto_instance_following(self):
        """Gets the auto_instance_following of this InlineObject3.  # noqa: E501


        :return: The auto_instance_following of this InlineObject3.  # noqa: E501
        :rtype: NotificationSettingValue
        """
        return self._auto_instance_following

    @auto_instance_following.setter
    def auto_instance_following(self, auto_instance_following):
        """Sets the auto_instance_following of this InlineObject3.


        :param auto_instance_following: The auto_instance_following of this InlineObject3.  # noqa: E501
        :type auto_instance_following: NotificationSettingValue
        """

        self._auto_instance_following = auto_instance_following

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InlineObject3):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, InlineObject3):
            return True

        return self.to_dict() != other.to_dict()
